diff --git a/src/common/resources/lang/en_US/stats.lang b/src/common/resources/lang/en_US/stats.lang
index f302a8bfa..2ae4118b9 100644
--- a/src/common/resources/lang/en_US/stats.lang
+++ b/src/common/resources/lang/en_US/stats.lang
@@ -87,4 +87,37 @@ achievement.getChainmail.desc=Wear a set of fully repaired chainmail armor
 achievement.openGuidebook=Recipe for Success
 achievement.openGuidebook.desc=Press '%1$s' to open the guidebook.
 achievement.caughtEmAll=Caught 'Em All!
-achievement.caughtEmAll.desc=Collect every color of firefly in a jar.
\ No newline at end of file
+achievement.caughtEmAll.desc=Collect every color of firefly in a jar.
+achievement.craftIcecream=Cherry on Top
+achievement.craftIcecream.desc=Craft an ice cream bucket.
+achievement.craftPumpkinPie=Autumn Special
+achievement.craftPumpkinPie.desc=Craft a pumpkin pie.
+achievement.getDiamonds=Diamonds!
+achievement.getDiamonds.desc=Mine diamond ore to a diamond.
+achievement.allArmorTypes=Master of None
+achievement.allArmorTypes.desc=Wear an armor piece from 4 different sets.
+achievement.allMusicDiscs=Music Collector
+achievement.allMusicDiscs.desc=Collect all music discs.
+achievement.tripleHit=Three for One Deal!
+achievement.tripleHit.desc=Hit three mobs with a single golden arrow.
+
+achievement.enterNether=The Inferno
+achievement.enterNether.desc=Enter the Nether
+achievement.swimNether=Frozen Over
+achievement.swimNether.desc=Melt some ice and take a swim.
+achievement.enterOldworld=As Above...
+achievement.enterOldworld.desc=Enter the Old World
+achievement.enterWarrens=...So Below
+achievement.enterWarrens.desc=Enter the Warrens
+achievement.getNethercoal=Fiery Fuel
+achievement.getNethercoal.desc=Mine some nethercoal from the Nether.
+achievement.hitFireball=I can do Better
+achievement.hitFireball.desc=Hit a Ghast's fireball at another mob.
+achievement.sleepNether=Rude Awakening
+achievement.sleepNether.desc=Attempt to sleep in the Nether.
+achievement.lightSign=Glow in the Dark
+achievement.lightSign.desc=Apply glowstone dust to a sign.
+achievement.mostWanted=Most Wanted
+achievement.mostWanted.desc=Have more then 10 Zombie Pigmen attack you.
+achievement.fastTravel=Dimensional Slingshot
+achievement.fastTravel.desc=Use the Nether to travel more then 8000 blocks in the Overworld.
\ No newline at end of file
diff --git a/src/main/java/com/mojang/nbt/Tag.java b/src/main/java/com/mojang/nbt/Tag.java
index 2d2108ba1..cf6184e0b 100644
--- a/src/main/java/com/mojang/nbt/Tag.java
+++ b/src/main/java/com/mojang/nbt/Tag.java
@@ -108,11 +108,8 @@ public abstract class Tag<T>
         else
         {
             Tag<?> tag = newTag(typeId);
-            if (tag != null)
-            {
-                tag.name = dis.readUTF();
-                tag.read(dis);
-            }
+            tag.name = dis.readUTF();
+            tag.read(dis);
             return tag;
         }
     }
@@ -187,8 +184,7 @@ public abstract class Tag<T>
      * @param type The ID of the type of tag to create.
      * @return The created tag, or null if the type ID doesn't match any tag types.
      */
-    public static Tag<?> newTag(byte type)
-    {
+    public static Tag<?> newTag(byte type) throws IOException {
         switch(type)
         {
         case 0:
@@ -218,7 +214,7 @@ public abstract class Tag<T>
         case 12:
         	return new DoubleArrayTag();
         }
-        return null;
+        throw new IOException("Cannot read NBT Tag type for type '" + type + "'!");
     }
 
     /**
diff --git a/src/main/java/net/betterthanadventure/utils/BiomeFinder.java b/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
index e56e5db6c..5f3b15b42 100644
--- a/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
+++ b/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
@@ -137,10 +137,13 @@ public class BiomeFinder implements MinecraftAccessor {
 			worldDirectory = new File("");
 		}
 
-		Global.accessor = this;
-
 		frame = new JFrame(title);
-		frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
+		if (Global.accessor != null) {
+			frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
+		} else {
+			frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
+			Global.accessor = this;
+		}
 
         try {
             UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); //set Look and Feel to Windows
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 0a3eb716d..6ad3ac2e5 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -2082,6 +2082,17 @@ public class Minecraft
         x *= Dimension.getCoordScale(lastDim, newDim);
         z *= Dimension.getCoordScale(lastDim, newDim);
         thePlayer.moveTo(x, y, z, thePlayer.yRot, thePlayer.xRot);
+        ChunkCoordinates newCoordinates = new ChunkCoordinates(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
+        if (thePlayer.dimensionEnterCoordinate != null) {
+            double dx = thePlayer.dimensionEnterCoordinate.x - x;
+            double dy = thePlayer.dimensionEnterCoordinate.y - y;
+            double dz = thePlayer.dimensionEnterCoordinate.z - z;
+            double distSqr = (dx * dx) + (dy * dy) + (dz * dz);
+            if (distSqr > 8000 * 8000) {
+                thePlayer.addStat(Achievements.FAST_TRAVEL, 1);
+            }
+        }
+        thePlayer.dimensionEnterCoordinate = newCoordinates;
         if(thePlayer.isAlive())
         {
             theWorld.updateEntityWithOptionalForce(thePlayer, false);
diff --git a/src/main/java/net/minecraft/client/gui/GuiException.java b/src/main/java/net/minecraft/client/gui/GuiException.java
index ca0860130..71de3b752 100644
--- a/src/main/java/net/minecraft/client/gui/GuiException.java
+++ b/src/main/java/net/minecraft/client/gui/GuiException.java
@@ -30,7 +30,7 @@ public class GuiException {
                 .append(TextFormatting.WHITE).append(".\n\n");
         try
         {
-            s.append("Generated ").append((new SimpleDateFormat()).format(new Date())).append("\n\n");
+            s.append(TextFormatting.WHITE).append("Generated ").append((new SimpleDateFormat()).format(new Date())).append("\n\n");
             s.append("Minecraft: Better than Adventure! ").append(Minecraft.VERSION).append("\n");
             s.append("OS: ").append(System.getProperty("os.name")).append(" (").append(System.getProperty("os.arch")).append(") version ").append(System.getProperty("os.version")).append("\n");
             s.append("Java: ").append(System.getProperty("java.version")).append(", ").append(System.getProperty("java.vendor")).append("\n");
@@ -52,7 +52,7 @@ public class GuiException {
 
 
         GuiPopup popup = new PopupBuilder(parent,860/scale).withLabel("gui.exception.label.exception_occurred")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),150/scale)
+                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.fontRenderer.getCharWidth('m'))
                 .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.back","gui.exception.button.copy_error"},new int[]{0,1})
                 .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
                 .build();
@@ -73,7 +73,7 @@ public class GuiException {
                 .append(TextFormatting.WHITE).append(".\n\n");
         try
         {
-            s.append("Generated ").append((new SimpleDateFormat()).format(new Date())).append("\n\n");
+            s.append(TextFormatting.WHITE).append("Generated ").append((new SimpleDateFormat()).format(new Date())).append("\n\n");
             s.append("Minecraft: Better than Adventure! ").append(Minecraft.VERSION).append("\n");
             s.append("OS: ").append(System.getProperty("os.name")).append(" (").append(System.getProperty("os.arch")).append(") version ").append(System.getProperty("os.version")).append("\n");
             s.append("Java: ").append(System.getProperty("java.version")).append(", ").append(System.getProperty("java.vendor")).append("\n");
@@ -96,7 +96,7 @@ public class GuiException {
         GuiBlank gui = new GuiBlank();
         mc.displayGuiScreen(gui);
         GuiPopup popup = new PopupBuilder(gui,860/scale).withLabel("gui.exception.label.fatal_error")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),150/scale)
+                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.fontRenderer.getCharWidth('m'))
                 .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.copy_error","gui.exception.button.copy_error_and_quit"},new int[]{0,2},new boolean[]{false,true})
                 .withBackgroundColor(0xff402020, 0xff501010)
                 .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
@@ -118,7 +118,7 @@ public class GuiException {
                 .append(TextFormatting.WHITE).append(".\n\n");
         try
         {
-            s.append("Generated ").append((new SimpleDateFormat()).format(new Date())).append("\n\n");
+            s.append(TextFormatting.WHITE).append("Generated ").append((new SimpleDateFormat()).format(new Date())).append("\n\n");
             s.append("Minecraft: Better than Adventure! ").append(Minecraft.VERSION).append("\n");
             s.append("OS: ").append(System.getProperty("os.name")).append(" (").append(System.getProperty("os.arch")).append(") version ").append(System.getProperty("os.version")).append("\n");
             s.append("Java: ").append(System.getProperty("java.version")).append(", ").append(System.getProperty("java.vendor")).append("\n");
@@ -141,7 +141,7 @@ public class GuiException {
         GuiBlank gui = new GuiBlank();
         mc.displayGuiScreen(gui);
         GuiPopup popup = new PopupBuilder(gui,860/scale).withLabel("gui.exception.label.startup_error")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),150/scale)
+                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.fontRenderer.getCharWidth('m'))
                 .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.copy_error","gui.exception.button.copy_error_and_quit"},new int[]{0,2},new boolean[]{false,true})
                 .withBackgroundColor(0xff402020, 0xff501010)
                 .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
diff --git a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
index 3d32ea5e1..d6798d336 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
@@ -11,16 +11,21 @@ import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.ArrayList;
 import java.util.List;
+import java.util.Objects;
 import java.util.Random;
 
 public abstract class AchievementPage {
+    private final List<Achievement> achievementList = new ArrayList<>();
 
     public abstract @NotNull String getName();
 
     public abstract @NotNull String getDescription();
 
-    public abstract void addAchievement(@NotNull Achievement achievement);
+    public void addAchievement(@NotNull Achievement achievement) {
+        achievementList.add(Objects.requireNonNull(achievement));
+    }
 
     public abstract @NotNull Achievement onOpenAchievement();
 
@@ -30,15 +35,27 @@ public abstract class AchievementPage {
 
     public abstract @NotNull ItemStack getIcon();
 
-    public abstract @NotNull List<Achievement> getAchievements();
+    public @NotNull List<Achievement> getAchievements() {
+        return achievementList;
+    }
 
-    public abstract double getCompletionFraction(StatsCounter counter);
+    public double getCompletionFraction(StatsCounter counter) {
+        int completed = 0;
+        for (Achievement a : achievementList) {
+            if (counter.isUnlocked(a)) {
+                completed++;
+            }
+        }
+        return completed / (double) achievementList.size();
+    }
 
     public abstract int backgroundLayers();
 
     public abstract int backgroundColor();
 
-    public abstract boolean hasAchievement(Achievement achievement);
+    public boolean hasAchievement(Achievement achievement) {
+        return achievementList.contains(achievement);
+    }
 
     public abstract IconCoordinate getAchievementIcon(Achievement achievement);
 
@@ -48,7 +65,7 @@ public abstract class AchievementPage {
 
     public abstract int lineColorCanUnlock(boolean isHovered);
 
-    public static IconCoordinate getTextureFromBlock(Block block){
+    public static IconCoordinate getTextureFromBlock(Block block) {
         return BlockModelDispatcher.getInstance().getDispatch(block).getBlockTextureFromSideAndMetadata(Side.TOP, 0);
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
index 072688dbc..232b0d142 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
@@ -1,8 +1,7 @@
 package net.minecraft.client.gui.achievements.data;
 
-import net.minecraft.client.gui.achievements.pages.DefaultPage;
-import net.minecraft.client.gui.achievements.pages.NetherPage;
 import net.minecraft.client.gui.achievements.pages.OverworldPage;
+import net.minecraft.client.gui.achievements.pages.NetherPage;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Blocks;
 
@@ -19,25 +18,8 @@ public class AchievementPages {
     public static void init(){
         if (hasInit) return;
         hasInit = true;
-        overworldPage = register(new OverworldPage());
-        netherPage = register(new NetherPage());
-//        netherPage = new NetherPage();
-
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
-        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        overworldPage = register(new OverworldPage("gui.achievements.page.overworld", Blocks.GRASS.getDefaultStack()));
+        netherPage = register(new NetherPage("gui.achievements.page.nether", Blocks.NETHERRACK.getDefaultStack()));
     }
     static {
         Achievements.init();
diff --git a/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java b/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java
index 4eb6a4090..46720681f 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java
@@ -1,32 +1,114 @@
 package net.minecraft.client.gui.achievements.pages;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.achievements.GuiAchievements;
+import net.minecraft.client.gui.achievements.data.AchievementPage;
+import net.minecraft.client.gui.achievements.data.AchievementPages;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.achievement.Achievement;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class NetherPage extends DefaultPage{
-    public NetherPage() {
-        super("gui.achievements.page.nether", Blocks.NETHERRACK.getDefaultStack());
+public class NetherPage extends AchievementPage {
+    protected final Minecraft mc = Minecraft.getMinecraft(this);
+    protected final ItemStack icon;
+    @NotNull
+    protected final String key;
+
+    public NetherPage(String key, ItemStack icon) {
+        this.key = key;
+        this.icon = icon;
+    }
+
+    @Override
+    public @NotNull String getName() {
+        return I18n.getInstance().translateNameKey(key);
     }
+
+    @Override
+    public @NotNull String getDescription() {
+        return I18n.getInstance().translateDescKey(key);
+    }
+
     @Override
     public @NotNull Achievement onOpenAchievement() {
-        return Achievements.BUILD_PICKAXE;
+        return Achievements.ENTER_NETHER;
     }
+
     @Override
     public IconCoordinate getBackgroundTile(GuiAchievements guiAchievements, int layer, Random random, int tileX, int tileY) {
-        int r = random.nextInt(5);
+        random.setSeed(random.nextLong() + key.hashCode()); // makes seed different for each instance of this class :)
+
+        final int bedrockLayer = 35;
+
+        final int offsetX = tileX + random.nextInt(3) - random.nextInt(3);
+        final int offsetY = tileY + random.nextInt(3) - random.nextInt(3);
+
+        int r = random.nextInt(50);
         IconCoordinate texture = getTextureFromBlock(Blocks.NETHERRACK);
-        if (r == 0){
+        if (offsetY >= bedrockLayer) {
+            texture = getTextureFromBlock(Blocks.BEDROCK);
+        } else if (r < 10) {
             texture = getTextureFromBlock(Blocks.ORE_NETHERCOAL_NETHERRACK);
         }
         return texture;
     }
 
+    @Override
+    public void postProcessBackground(GuiAchievements gui, Random random, GuiAchievements.BGLayer layerCache, int orgX, int orgY) {
+        if (layerCache.id == 0) {
+            int lastY = 0;
+            int cave = -1;
+            for (int _x = -100; _x <= 100; _x++) {
+                if (random.nextInt(20) == 0 && cave <= 0) {
+                    cave = 20 + random.nextInt(5) - random.nextInt(5);
+                }
+                if (cave > 0){
+                    lastY = (25 + random.nextInt(4) - random.nextInt(4));
+                    carveCircle(gui, layerCache, _x - orgX, lastY - orgY, 2 + random.nextInt(3));
+                }
+                cave--;
+            }
+            cave = -1;
+            for (int _x = -100; _x <= 100; _x++) {
+                if (random.nextInt(10) == 0 && cave <= 0) {
+                    cave = 5 + random.nextInt(5) - random.nextInt(5);
+                }
+                if (cave > 0){
+                    carveCircle(gui, layerCache, _x - orgX, (10 + random.nextInt(2) - random.nextInt(2)) - orgY, random.nextInt(3));
+                }
+                cave--;
+            }
+
+        }
+    }
+
+    @Override
+    public @NotNull ItemStack getIcon() {
+        return icon;
+    }
+
+    @Override
+    public int backgroundLayers() {
+        return 1;
+    }
+
+    @Override
+    public int backgroundColor() {
+        return 0x000000;
+    }
+
+    @Override
+    public IconCoordinate getAchievementIcon(Achievement achievement) {
+        return TextureRegistry.getTexture(achievement.getType().texture);
+    }
+
     @Override
     public int lineColorLocked(boolean isHovered) {
         return 0x002233;
@@ -41,4 +123,16 @@ public class NetherPage extends DefaultPage{
     public int lineColorCanUnlock(boolean isHovered) {
         return 0xff0000;
     }
+
+    protected void carveCircle(GuiAchievements gui, GuiAchievements.BGLayer layer, int centerX, int centerY, int radius){
+        for (int i = centerX - radius; i <= centerX + radius ; i++) {
+            for (int j = centerY - radius; j < centerY + radius; j++) {
+                double diffX = (i + 0.5) - centerX;
+                double diffY = (j + 0.5) - centerY;
+                if ((diffX * diffX) + (diffY * diffY) < radius * radius){
+                    layer.put(null, i, j);
+                }
+            }
+        }
+    }
 }
